Index: wp-admin/import/livejournal.php
===================================================================
--- wp-admin/import/livejournal.php	(revision 11691)
+++ wp-admin/import/livejournal.php	(working copy)
@@ -837,7 +837,7 @@
 		$this->ixr = new IXR_Client( $this->ixr_url, false, 80, 30 );
 
 		echo '<div id="ljapi-status">';
-		echo '<h3>' . __( 'Downloading Comments' ) . '</h3>';
+		echo '<h3>' . __( 'Downloading Comments&#8230;' ) . '</h3>';
 		echo '<p>' . __( 'Now we will download your comments so we can import them (this could take a <strong>long</strong> time if you have lots of comments)...' ) . '</p>';
 		ob_flush(); flush();
 
@@ -885,7 +885,7 @@
 		update_option( 'ljapi_step', 3 );
 
 		echo '<div id="ljapi-status">';
-		echo '<h3>' . __( 'Threading Comments' ) . '</h3>';
+		echo '<h3>' . __( 'Threading Comments&#8230;' ) . '</h3>';
 		echo '<p>' . __( 'We are now re-building the threading of your comments (this can also take a while if you have lots of comments)...' ) . '</p>';
 		ob_flush(); flush();
 
@@ -958,12 +958,12 @@
 			});
 
 			function ljapi_msg() {
-				str = '<?php _e( "Continuing in %d" ) ?>';
+				str = '<?php _e( "Continuing in %d&#8230;" ) ?>';
 				jQuery( '#<?php echo $msg ?>' ).text( str.replace( /%d/, next_counter ) );
 				if ( next_counter <= 0 ) {
 					if ( jQuery( '#<?php echo $id ?>' ).length ) {
 						jQuery( "#<?php echo $id ?> input[type='submit']" ).hide();
-						str = '<?php _e( "Continuing" ) ?> <img src="images/wpspin_light.gif" alt="" id="processing" align="top" />';
+						str = '<?php _e( "Continuing&#8230;" ) ?> <img src="images/wpspin_light.gif" alt="" id="processing" align="top" />';
 						jQuery( '#<?php echo $msg ?>' ).html( str );
 						jQuery( '#<?php echo $id ?>' ).submit();
 						return;
@@ -986,7 +986,7 @@
 			});
 
 			function ljapi_msg() {
-				str = '<?php _e( "Continuing in %d" ) ?>';
+				str = '<?php _e( "Continuing in %d&#8230;" ) ?>';
 				jQuery( '#<?php echo $msg ?>' ).text( str.replace( /%d/, next_counter ) );
 				if ( next_counter <= 0 ) {
 					if ( jQuery( '#<?php echo $id ?>' ).length ) {
Index: wp-admin/includes/class-wp-upgrader.php
===================================================================
--- wp-admin/includes/class-wp-upgrader.php	(revision 11691)
+++ wp-admin/includes/class-wp-upgrader.php	(working copy)
@@ -51,13 +51,13 @@
 		$this->strings['fs_no_folder'] = __('Unable to locate needed folder (%s).');
 
 		$this->strings['download_failed'] = __('Download failed.');
-		$this->strings['installing_package'] = __('Installing the latest version.');
+		$this->strings['installing_package'] = __('Installing the latest version&#8230;');
 		$this->strings['folder_exists'] = __('Destination folder already exists.');
 		$this->strings['mkdir_failed'] = __('Could not create directory.');
 		$this->strings['bad_package'] = __('Incompatible Archive');
 
-		$this->strings['maintenance_start'] = __('Enabling Maintenance mode.');
-		$this->strings['maintenance_end'] = __('Disabling Maintenance mode.');
+		$this->strings['maintenance_start'] = __('Enabling Maintenance mode&#8230;');
+		$this->strings['maintenance_end'] = __('Disabling Maintenance mode&#8230;');
 	}
 
 	function fs_connect( $directories = array() ) {
@@ -348,22 +348,22 @@
 	function upgrade_strings() {
 		$this->strings['up_to_date'] = __('The plugin is at the latest version.');
 		$this->strings['no_package'] = __('Upgrade package not available.');
-		$this->strings['downloading_package'] = __('Downloading update from <span class="code">%s</span>.');
-		$this->strings['unpack_package'] = __('Unpacking the update.');
-		$this->strings['deactivate_plugin'] = __('Deactivating the plugin.');
-		$this->strings['remove_old'] = __('Removing the old version of the plugin.');
+		$this->strings['downloading_package'] = __('Downloading update from <span class="code">%s</span>&#8230;');
+		$this->strings['unpack_package'] = __('Unpacking the update&#8230;');
+		$this->strings['deactivate_plugin'] = __('Deactivating the plugin&#8230;');
+		$this->strings['remove_old'] = __('Removing the old version of the plugin&#8230;');
 		$this->strings['remove_old_failed'] = __('Could not remove the old plugin.');
-		$this->strings['process_failed'] = __('Plugin upgrade Failed.');
+		$this->strings['process_failed'] = __('Plugin upgrade failed.');
 		$this->strings['process_success'] = __('Plugin upgraded successfully.');
 	}
 
 	function install_strings() {
 		$this->strings['no_package'] = __('Install package not available.');
-		$this->strings['downloading_package'] = __('Downloading install package from <span class="code">%s</span>.');
-		$this->strings['unpack_package'] = __('Unpacking the package.');
-		$this->strings['installing_package'] = __('Installing the plugin.');
-		$this->strings['process_failed'] = __('Plugin Install Failed.');
-		$this->strings['process_success'] = __('Plugin Installed successfully.');
+		$this->strings['downloading_package'] = __('Downloading install package from <span class="code">%s</span>&#8230;');
+		$this->strings['unpack_package'] = __('Unpacking the package&#8230;');
+		$this->strings['installing_package'] = __('Installing the plugin&#8230;');
+		$this->strings['process_failed'] = __('Plugin install failed.');
+		$this->strings['process_success'] = __('Plugin installed successfully.');
 	}
 
 	function install($package) {
@@ -504,21 +504,21 @@
 	function upgrade_strings() {
 		$this->strings['up_to_date'] = __('The theme is at the latest version.');
 		$this->strings['no_package'] = __('Upgrade package not available.');
-		$this->strings['downloading_package'] = __('Downloading update from <span class="code">%s</span>.');
-		$this->strings['unpack_package'] = __('Unpacking the update.');
-		$this->strings['remove_old'] = __('Removing the old version of the theme.');
+		$this->strings['downloading_package'] = __('Downloading update from <span class="code">%s</span>&#8230;');
+		$this->strings['unpack_package'] = __('Unpacking the update&#8230;');
+		$this->strings['remove_old'] = __('Removing the old version of the theme&#8230;');
 		$this->strings['remove_old_failed'] = __('Could not remove the old theme.');
-		$this->strings['process_failed'] = __('Theme upgrade Failed.');
+		$this->strings['process_failed'] = __('Theme upgrade failed.');
 		$this->strings['process_success'] = __('Theme upgraded successfully.');
 	}
 
 	function install_strings() {
 		$this->strings['no_package'] = __('Install package not available.');
-		$this->strings['downloading_package'] = __('Downloading install package from <span class="code">%s</span>.');
-		$this->strings['unpack_package'] = __('Unpacking the package.');
-		$this->strings['installing_package'] = __('Installing the theme.');
-		$this->strings['process_failed'] = __('Theme Install Failed.');
-		$this->strings['process_success'] = __('Theme Installed successfully.');
+		$this->strings['downloading_package'] = __('Downloading install package from <span class="code">%s</span>&#8230;');
+		$this->strings['unpack_package'] = __('Unpacking the package&#8230;');
+		$this->strings['installing_package'] = __('Installing the theme&#8230;');
+		$this->strings['process_failed'] = __('Theme install failed.');
+		$this->strings['process_success'] = __('Theme installed successfully.');
 	}
 
 	function install($package) {
@@ -661,8 +661,8 @@
 	function upgrade_strings() {
 		$this->strings['up_to_date'] = __('WordPress is at the latest version.');
 		$this->strings['no_package'] = __('Upgrade package not available.');
-		$this->strings['downloading_package'] = __('Downloading update from <span class="code">%s</span>.');
-		$this->strings['unpack_package'] = __('Unpacking the update.');
+		$this->strings['downloading_package'] = __('Downloading update from <span class="code">%s</span>&#8230;');
+		$this->strings['unpack_package'] = __('Unpacking the update&#8230;');
 		$this->strings['copy_failed'] = __('Could not copy files.');
 	}
 
@@ -822,7 +822,7 @@
 	function after() {
 		$this->plugin = $this->upgrader->plugin_info();
 		if( !empty($this->plugin) && !is_wp_error($this->result) && $this->plugin_active ){
-			show_message(__('Attempting reactivation of the plugin'));
+			show_message(__('Reactivating the plugin&#8230;'));
 			echo '<iframe style="border:0;overflow:hidden" width="100%" height="170px" src="' . wp_nonce_url('update.php?action=activate-plugin&plugin=' . $this->plugin, 'activate-plugin_' . $this->plugin) .'"></iframe>';
 		}
 		$update_actions =  array(
Index: wp-admin/includes/update-core.php
===================================================================
--- wp-admin/includes/update-core.php	(revision 11691)
+++ wp-admin/includes/update-core.php	(working copy)
@@ -210,14 +210,14 @@
 	@set_time_limit( 300 );
 
 	// Sanity check the unzipped distribution
-	apply_filters('update_feedback', __('Verifying the unpacked files'));
+	apply_filters('update_feedback', __('Verifying the unpacked files&#8230;'));
 	if ( !$wp_filesystem->exists($from . '/wordpress/wp-settings.php') || !$wp_filesystem->exists($from . '/wordpress/wp-admin/admin.php') ||
 		!$wp_filesystem->exists($from . '/wordpress/wp-includes/functions.php') ) {
 		$wp_filesystem->delete($from, true);
 		return new WP_Error('insane_distro', __('The update could not be unpacked') );
 	}
 
-	apply_filters('update_feedback', __('Installing the latest version'));
+	apply_filters('update_feedback', __('Installing the latest version&#8230;'));
 
 	// Create maintenance file to signal that we are upgrading
 	$maintenance_string = '<?php $upgrading = ' . time() . '; ?>';
@@ -242,7 +242,7 @@
 	}
 
 	// Upgrade DB with separate request
-	apply_filters('update_feedback', __('Upgrading database'));
+	apply_filters('update_feedback', __('Upgrading database&#8230;'));
 	$db_upgrade_url = admin_url('upgrade.php?step=upgrade_db');
 	wp_remote_post($db_upgrade_url, array('timeout' => 60));
 