Index: wp-includes/default-filters.php
===================================================================
--- wp-includes/default-filters.php	(revision 23621)
+++ wp-includes/default-filters.php	(working copy)
@@ -250,7 +250,7 @@
 add_action( 'plugins_loaded',             'wp_maybe_load_widgets',                    0    );
 add_action( 'plugins_loaded',             'wp_maybe_load_embeds',                     0    );
 add_action( 'shutdown',                   'wp_ob_end_flush_all',                      1    );
-add_action( 'pre_post_update',            'wp_save_post_revision',                   10, 2 );
+add_action( 'post_post_update',           'wp_save_post_revision',                   10, 2 );
 add_action( 'publish_post',               '_publish_post_hook',                       5, 1 );
 add_action( 'transition_post_status',     '_transition_post_status',                  5, 3 );
 add_action( 'transition_post_status',     '_update_term_count_on_transition_post_status', 10, 3 );
Index: wp-includes/post.php
===================================================================
--- wp-includes/post.php	(revision 23621)
+++ wp-includes/post.php	(working copy)
@@ -2878,6 +2878,8 @@
 
 	if ( $update ) {
 		do_action('edit_post', $post_ID, $post);
+		do_action( 'post_post_update', $post_ID, $data );
+
 		$post_after = get_post($post_ID);
 		do_action( 'post_updated', $post_ID, $post_after, $post_before);
 	}
Index: wp-includes/revision.php
===================================================================
--- wp-includes/revision.php	(revision 23621)
+++ wp-includes/revision.php	(working copy)
@@ -82,40 +82,46 @@
 	if ( ! WP_POST_REVISIONS )
 		return;
 
-	if ( !$post = get_post( $post_id, ARRAY_A ) )
+	if ( ! $post = get_post( $post_id, ARRAY_A ) )
 		return;
 
 	if ( 'auto-draft' == $post['post_status'] )
 		return;
 
-	if ( !post_type_supports($post['post_type'], 'revisions') )
+	if ( ! post_type_supports( $post['post_type'], 'revisions' ) )
 		return;
 
 	// if new data is supplied, check that it is different from last saved revision, unless a plugin tells us to always save regardless
-	if ( apply_filters( 'wp_save_post_revision_check_for_changes', true, $post, $new_data ) && is_array( $new_data ) ) {
-		$post_has_changed = false;
-		foreach ( array_keys( _wp_post_revision_fields() ) as $field ) {
-			if ( normalize_whitespace( $new_data[ $field ] ) != normalize_whitespace( $post[ $field ] ) ) {
-				$post_has_changed = true;
-				break;
+	if ( $revisions = wp_get_post_revisions( $post_id ) ) { // grab the last revision
+		$last_revision = array_shift( $revisions );
+		if ( ! $last_revision_array = get_post( $last_revision->ID, ARRAY_A ) ) //if no previous revisions, save one for sure
+			return;
+
+		if ( apply_filters( 'wp_save_post_revision_check_for_changes', true, $last_revision_array, $new_data ) && is_array( $new_data ) ) {
+			$post_has_changed = false;
+			foreach ( array_keys( _wp_post_revision_fields() ) as $field ) {
+				if ( normalize_whitespace( $new_data[ $field ] ) != normalize_whitespace( $last_revision_array[ $field ] ) ) {
+					$post_has_changed = true;
+					break;
+				}
 			}
+			//don't save revision if post unchanged
+			if( ! $post_has_changed )
+				return;
 		}
-		//don't save revision if post unchanged
-		if( ! $post_has_changed )
-			return;
 	}
 
 	$return = _wp_put_post_revision( $post );
 
 	// WP_POST_REVISIONS = true (default), -1
-	if ( !is_numeric( WP_POST_REVISIONS ) || WP_POST_REVISIONS < 0 )
+	if ( ! is_numeric( WP_POST_REVISIONS ) || WP_POST_REVISIONS < 0 )
 		return $return;
 
 	// all revisions and (possibly) one autosave
 	$revisions = wp_get_post_revisions( $post_id, array( 'order' => 'ASC' ) );
 
 	// WP_POST_REVISIONS = (int) (# of autosaves to save)
-	$delete = count($revisions) - WP_POST_REVISIONS;
+	$delete = count( $revisions ) - WP_POST_REVISIONS;
 
 	if ( $delete < 1 )
 		return $return;
@@ -123,9 +129,9 @@
 	$revisions = array_slice( $revisions, 0, $delete );
 
 	for ( $i = 0; isset($revisions[$i]); $i++ ) {
-		if ( false !== strpos( $revisions[$i]->post_name, 'autosave' ) )
+		if ( false !== strpos( $revisions[ $i ]->post_name, 'autosave' ) )
 			continue;
-		wp_delete_post_revision( $revisions[$i]->ID );
+		wp_delete_post_revision( $revisions[ $i ]->ID );
 	}
 
 	return $return;